State maintenance in Vue Dashboard Layout component

The current layout structure of the Dashboard Layout component can be obtained and saved to recreate a dashboard with the same panel structure using the serialize public method. This method returns the component’s current panel settings, which can be used to construct a dashboard with the same layout configuration.

The following sample demonstrates how to save and restore the state of the panels using the serialize method. Click Save to store the panels’ settings and click Restore to apply the previously saved settings.

<template>
  <div>
    <div className="col-lg-8 control-section" id="control_dash">
      <div className="content-wrapper">
        <ejs-dashboardlayout id='dashboard_default' ref="dashboard" :cellSpacing='cellSpacing' :columns="7"
          :created="onSave">
          <e-panels>
            <e-panel :sizeX="1" :sizeY="1" :row="0" :col="0" content="<div class='content'>0</div>"></e-panel>
            <e-panel :sizeX="3" :sizeY="2" :row="0" :col="1" content="<div class='content'>1</div>"></e-panel>
            <e-panel :sizeX="1" :sizeY="3" :row="0" :col="4" content="<div class='content'>2</div>"></e-panel>
            <e-panel :sizeX="1" :sizeY="1" :row="1" :col="0" content="<div class='content'>3</div>"></e-panel>
            <e-panel :sizeX="2" :sizeY="1" :row="2" :col="0" content="<div class='content'>4</div>"></e-panel>
            <e-panel :sizeX="1" :sizeY="1" :row="2" :col="2" content="<div class='content'>5</div>"></e-panel>
            <e-panel :sizeX="1" :sizeY="1" :row="2" :col="3" content="<div class='content'>6</div>"></e-panel>
          </e-panels>
        </ejs-dashboardlayout>
      </div>
    </div>
    <div className="col-lg-4 property-section dashboard" id="api_property">
      <div className="row property-panel-content">
        <div className="card-body">
          <div className="form-group row">
            <table id="remove">
              <tbody>
                <tr>
                  <td> Properties Panel </td>
                </tr>
                <tr>
                  <td>
                    <!--  Button component declaration -->
                    <ejs-button id="save" cssClass="e-primary" v-on:click="onSave">Save Panel</ejs-button>
                  </td>
                  <td>
                    <!--  Button component declaration -->
                    <ejs-button id="restore" cssClass="e-flat e-outline" v-on:click="onRestore">Restore
                      Panel</ejs-button>
                  </td>
                </tr>
              </tbody>
            </table>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
  
<script setup>
  
  // Import syncfusion Dashboard Layout component from layouts package
  import { DashboardLayoutComponent as EjsDashboardlayout, PanelDirective as EPanel, PanelsDirective as EPanels } from "@syncfusion/ej2-vue-layouts";
  // Import syncfusion button component from buttons package
  import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";
  import { ref } from 'vue';
  
  const dashboard = ref(null);
  const cellSpacing = [20, 20];
  let restoreModel = [];
  
  // Restore the initial panels
  const onRestore = () => {
    // Create instances for Dashboard Layout component
    dashboard.value.$el.ej2_instances[0].panels = restoreModel;
  };
  
  // Save the current panels
  const onSave = () => {
    // Create instances for Dashboard Layout component
    restoreModel = dashboard.value.$el.ej2_instances[0].serialize();
    restoreModel[0].content = '<div class="content">0</div>';
    restoreModel[1].content = '<div class="content">1</div>';
    restoreModel[2].content = '<div class="content">2</div>';
    restoreModel[3].content = '<div class="content">3</div>';
    restoreModel[4].content = '<div class="content">4</div>';
    restoreModel[5].content = '<div class="content">5</div>';
    restoreModel[6].content = '<div class="content">6</div>';
  };
  
</script>
  
<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-vue-layouts/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
  
  /* Dashboard Layout component styles  */
  #dashboard_default .e-panel .e-panel-content {
    vertical-align: middle;
    font-weight: 600;
    font-size: 20px;
    text-align: center;
    line-height: 50px;
  }
  
  #control_dash {
    display: block;
    width: 60%;
    float: left;
  }
  
  #api_property {
    display: inline-block;
  }
  
  #float_id {
    border: 1px solid black;
    padding: 20px;
    margin: 30px;
  }
  
  #remove {
    border: 1px solid black;
    margin: 30px;
  }
  
  td {
    padding: 20px;
  }
  
  #dashboard_default .e-panel {
    transition: none !important;
  }
</style>
<template>
    <div>
        <div className="col-lg-8 control-section" id="control_dash">
            <div className="content-wrapper">
                <ejs-dashboardlayout id='dashboard_default' ref="dashboard" :cellSpacing='cellSpacing' :columns="7"
                    :created="onSave">
                    <e-panels>
                        <e-panel :sizeX="1" :sizeY="1" :row="0" :col="0"
                            content="<div class='content'>0</div>"></e-panel>
                        <e-panel :sizeX="3" :sizeY="2" :row="0" :col="1"
                            content="<div class='content'>1</div>"></e-panel>
                        <e-panel :sizeX="1" :sizeY="3" :row="0" :col="4"
                            content="<div class='content'>2</div>"></e-panel>
                        <e-panel :sizeX="1" :sizeY="1" :row="1" :col="0"
                            content="<div class='content'>3</div>"></e-panel>
                        <e-panel :sizeX="2" :sizeY="1" :row="2" :col="0"
                            content="<div class='content'>4</div>"></e-panel>
                        <e-panel :sizeX="1" :sizeY="1" :row="2" :col="2"
                            content="<div class='content'>5</div>"></e-panel>
                        <e-panel :sizeX="1" :sizeY="1" :row="2" :col="3"
                            content="<div class='content'>6</div>"></e-panel>
                    </e-panels>
                </ejs-dashboardlayout>
            </div>
        </div>
        <div className="col-lg-4 property-section dashboard" id="api_property">
            <div className="row property-panel-content">
                <div className="card-body">
                    <div className="form-group row">
                        <table id="remove">
                            <tbody>
                                <tr>
                                    <td> Properties Panel </td>
                                </tr>
                                <tr>
                                    <td>
                                        <!--  Button component declaration -->
                                        <ejs-button id="save" cssClass="e-primary" v-on:click.native="onSave">Save
                                            Panel</ejs-button>
                                    </td>
                                    <td>
                                        <!--  Button component declaration -->
                                        <ejs-button id="restore" cssClass="e-flat e-outline"
                                            v-on:click.native="onRestore">Restore Panel</ejs-button>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>

    // Import syncfusion Dashboard Layout component from layouts package
    import { DashboardLayoutComponent, PanelDirective, PanelsDirective } from "@syncfusion/ej2-vue-layouts";
    // Import syncfusion button component from buttons package
    import { ButtonComponent } from "@syncfusion/ej2-vue-buttons";

    export default {
        name: "App",
        components: {
            "ejs-dashboardlayout": DashboardLayoutComponent,
            "e-panels": PanelsDirective,
            "e-panel": PanelDirective,
            "ejs-button": ButtonComponent
        },

        data: function () {
            return {
                cellSpacing: [20, 20],
                restoreModel: []
            };
        },
        methods: {
            // Restore the initial panels
            onRestore: function () {
                // Create instances for Dashboard Layout component
                this.$refs.dashboard.$el.ej2_instances[0].panels = this.restoreModel;
            },

            // Save the current panels
            onSave: function () {
                // Create instances for Dashboard Layout component
                this.restoreModel = this.$refs.dashboard.$el.ej2_instances[0].serialize();
                this.restoreModel[0].content = '<div class="content">0</div>';
                this.restoreModel[1].content = '<div class="content">1</div>';
                this.restoreModel[2].content = '<div class="content">2</div>';
                this.restoreModel[3].content = '<div class="content">3</div>';
                this.restoreModel[4].content = '<div class="content">4</div>';
                this.restoreModel[5].content = '<div class="content">5</div>';
                this.restoreModel[6].content = '<div class="content">6</div>';
            },
        },
    }
</script>

<style>
    @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
    @import "../node_modules/@syncfusion/ej2-vue-layouts/styles/material3.css";
    @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";

    /* Dashboard Layout component styles  */
    #dashboard_default .e-panel .e-panel-content {
        vertical-align: middle;
        font-weight: 600;
        font-size: 20px;
        text-align: center;
        line-height: 50px;
    }

    #control_dash {
        display: block;
        width: 60%;
        float: left;
    }

    #api_property {
        display: inline-block;
    }

    #float_id {
        border: 1px solid black;
        padding: 20px;
        margin: 30px;
    }

    #remove {
        border: 1px solid black;
        margin: 30px;
    }

    td {
        padding: 20px;
    }

    #dashboard_default .e-panel {
        transition: none !important;
    }
</style>

State Persistence in Vue Dashboard Layout Component

State persistence retains panel positions (row, col), width (sizeX), and height (sizeY) values in the browser’s localStorage for state maintenance, even if the browser is refreshed or if you navigate to another page within the browser. This feature is controlled through the enablePersistence property, which is set to false by default. When set to true, the panel positions and sizes of the Dashboard Layout component persist across page refreshes and navigation within the same browser.

<template>
  <div>
    <div className="col-lg-8 control-section" id="control_dash">
      <div className="content-wrapper">
        <ejs-dashboardlayout id='defaultLayout' :enablePersistence='enablePersistence' :cellSpacing='cellSpacing' :columns="7">
          <e-panels>
            <e-panel :sizeX="1" :sizeY="1" :row="0" :col="0" content="<div class='panel-content'>0</div>"></e-panel>
            <e-panel :sizeX="3" :sizeY="2" :row="0" :col="1" content="<div class='panel-content'>1</div>"></e-panel>
            <e-panel :sizeX="1" :sizeY="3" :row="0" :col="4" content="<div class='panel-content'>2</div>"></e-panel>
            <e-panel :sizeX="1" :sizeY="1" :row="1" :col="0" content="<div class='panel-content'>3</div>"></e-panel>
            <e-panel :sizeX="2" :sizeY="1" :row="2" :col="0" content="<div class='panel-content'>4</div>"></e-panel>
            <e-panel :sizeX="1" :sizeY="1" :row="2" :col="2" content="<div class='panel-content'>5</div>"></e-panel>
            <e-panel :sizeX="1" :sizeY="1" :row="2" :col="3" content="<div class='panel-content'>6</div>"></e-panel>
          </e-panels>
        </ejs-dashboardlayout>
      </div>
    </div>
  </div>
</template>
  
<script setup>
  
  // Import syncfusion Dashboard Layout component from layouts package
  import { DashboardLayoutComponent as EjsDashboardlayout, PanelDirective as EPanel, PanelsDirective as EPanels } from "@syncfusion/ej2-vue-layouts";
  
  const cellSpacing = [20, 20];

  const enablePersistence = true;
  
</script>
  
<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-vue-layouts/styles/material3.css";
  @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";
  
  /* Dashboard Layout component styles  */
  #defaultLayout .e-panel .e-panel-container {
    vertical-align: middle;
    font-weight: 600;
    font-size: 20px;
    text-align: center;
  }

  .panel-content {
    line-height: 80px;
  }
</style>
<template>
    <div>
        <div className="col-lg-8 control-section" id="control_dash">
            <div className="content-wrapper">
                <ejs-dashboardlayout id='defaultLayout' :enablePersistence='enablePersistence' :cellSpacing='cellSpacing' :columns="7">
                    <e-panels>
                        <e-panel :sizeX="1" :sizeY="1" :row="0" :col="0"
                            content="<div class='panel-content'>0</div>"></e-panel>
                        <e-panel :sizeX="3" :sizeY="2" :row="0" :col="1"
                            content="<div class='panel-content'>1</div>"></e-panel>
                        <e-panel :sizeX="1" :sizeY="3" :row="0" :col="4"
                            content="<div class='panel-content'>2</div>"></e-panel>
                        <e-panel :sizeX="1" :sizeY="1" :row="1" :col="0"
                            content="<div class='panel-content'>3</div>"></e-panel>
                        <e-panel :sizeX="2" :sizeY="1" :row="2" :col="0"
                            content="<div class='panel-content'>4</div>"></e-panel>
                        <e-panel :sizeX="1" :sizeY="1" :row="2" :col="2"
                            content="<div class='panel-content'>5</div>"></e-panel>
                        <e-panel :sizeX="1" :sizeY="1" :row="2" :col="3"
                            content="<div class='panel-content'>6</div>"></e-panel>
                    </e-panels>
                </ejs-dashboardlayout>
            </div>
        </div>
    </div>
</template>

<script>

    // Import syncfusion Dashboard Layout component from layouts package
    import { DashboardLayoutComponent, PanelDirective, PanelsDirective } from "@syncfusion/ej2-vue-layouts";

    export default {
        name: "App",
        components: {
            "ejs-dashboardlayout": DashboardLayoutComponent,
            "e-panels": PanelsDirective,
            "e-panel": PanelDirective,
        },

        data: function () {
            return {
                cellSpacing: [20, 20],
                enablePersistence: true,
            };
        },
    }
</script>

<style>
    @import "../node_modules/@syncfusion/ej2-base/styles/material3.css";
    @import "../node_modules/@syncfusion/ej2-vue-layouts/styles/material3.css";
    @import "../node_modules/@syncfusion/ej2-buttons/styles/material3.css";

    /* Dashboard Layout component styles  */
    #defaultLayout .e-panel .e-panel-container {
        vertical-align: middle;
        font-weight: 600;
        font-size: 20px;
        text-align: center;
    }

    .panel-content {
        line-height: 80px;
    }
</style>

Refer to the Vue Dashboard Layout feature tour page for its groundbreaking feature representations. Also explore the Vue Dashboard Layout example to knows how to present and manipulate data.

Save and Restore Layout State in React Dashboard Layout Component

The Dashboard Layout component provides the ability to save the current layout configuration and restore it later, enabling users to persist preferred panel arrangements across sessions or create reusable dashboard templates.

Save Layout State

The current layout structure of the Dashboard Layout component can be obtained and saved using the serialize public method of the component. This method returns the component’s current panel settings, which can be stored and later used to reconstruct a dashboard with the same layout configuration.

Implementation Example

The following sample demonstrates how to save and restore panel states using the serialize method. The Save button stores the current panel settings, while the Restore button applies the previously saved configuration.

import { DashboardLayoutComponent } from '@syncfusion/ej2-react-layouts';
import * as React from 'react';
function App() {
    let dashboardObj;
    const cellSpacing = [20, 20];
    let panels = [
        { "sizeX": 1, "sizeY": 1, "row": 0, "col": 0, content: '<div class="content">0</div>' },
        { "sizeX": 3, "sizeY": 2, "row": 0, "col": 1, content: '<div class="content">1</div>' },
        { "sizeX": 1, "sizeY": 3, "row": 0, "col": 4, content: '<div class="content">2</div>' },
        { "sizeX": 1, "sizeY": 1, "row": 1, "col": 0, content: '<div class="content">3</div>' },
        { "sizeX": 2, "sizeY": 1, "row": 2, "col": 0, content: '<div class="content">4</div>' },
        { "sizeX": 1, "sizeY": 1, "row": 2, "col": 2, content: '<div class="content">5</div>' },
        { "sizeX": 1, "sizeY": 1, "row": 2, "col": 3, content: '<div class="content">6</div>' }
    ];
    let restoreModel = [];
    function onRestore(args) {
        dashboardObj.panels = restoreModel;
    }
    function onSave(args) {
        restoreModel = dashboardObj.serialize();
        restoreModel[0].content = '<div class="content">0</div>';
        restoreModel[1].content = '<div class="content">1</div>';
        restoreModel[2].content = '<div class="content">2</div>';
        restoreModel[3].content = '<div class="content">3</div>';
        restoreModel[4].content = '<div class="content">4</div>';
        restoreModel[5].content = '<div class="content">5</div>';
        restoreModel[6].content = '<div class="content">6</div>';
    }
    return (<div>
      <div id='container'>
          <div className="inline" id="control">
              <DashboardLayoutComponent id='defaultLayout' created={onSave} ref={s => (dashboardObj = s)} cellSpacing={cellSpacing} panels={panels} columns={5}/>
          </div>
          <div className="inline" id="properties">
              <button className="e-btn e-primary" onClick={onSave}>Save</button>
              <button className="e-btn e-flat e-outline" id="restore" onClick={onRestore}>Restore</button>
          </div>
      </div>
  </div>);
}
export default App;
import {  DashboardLayoutComponent } from '@syncfusion/ej2-react-layouts';
import * as React from 'react';

function App(){
  let dashboardObj: DashboardLayoutComponent;
  const cellSpacing: number[] = [20, 20];
  let panels: any =   [
    { "sizeX": 1, "sizeY": 1, "row": 0, "col": 0, content:'<div class="content">0</div>' },
    { "sizeX": 3, "sizeY": 2, "row": 0, "col": 1, content:'<div class="content">1</div>' },
    { "sizeX": 1, "sizeY": 3, "row": 0, "col": 4, content:'<div class="content">2</div>' },
    { "sizeX": 1, "sizeY": 1, "row": 1, "col": 0, content:'<div class="content">3</div>' },
    { "sizeX": 2, "sizeY": 1, "row": 2, "col": 0, content:'<div class="content">4</div>' },
    { "sizeX": 1, "sizeY": 1, "row": 2, "col": 2, content:'<div class="content">5</div>' },
    { "sizeX": 1, "sizeY": 1, "row": 2, "col": 3, content:'<div class="content">6</div>' }
  ];
  let restoreModel: any = [];
  function onRestore(args: any): void {
    dashboardObj.panels = restoreModel;
  }
  function onSave(args: any): void {
    restoreModel = dashboardObj.serialize();
    restoreModel[0].content = '<div class="content">0</div>';
    restoreModel[1].content = '<div class="content">1</div>';
    restoreModel[2].content = '<div class="content">2</div>';
    restoreModel[3].content = '<div class="content">3</div>';
    restoreModel[4].content = '<div class="content">4</div>';
    restoreModel[5].content = '<div class="content">5</div>';
    restoreModel[6].content = '<div class="content">6</div>';
  }
  return (
  <div>
      <div id='container'>
          <div className="inline" id="control">
              <DashboardLayoutComponent id='defaultLayout' created={ onSave } ref={ s => (dashboardObj = s as DashboardLayoutComponent)} cellSpacing={cellSpacing}  panels={panels} columns={5} />
          </div>
          <div className="inline" id="properties">
              <button className="e-btn e-primary" onClick={onSave}>Save</button>
              <button className="e-btn e-flat e-outline" id="restore" onClick={onRestore}>Restore</button>
          </div>
      </div>
  </div>
  );
}
export default App;
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import App from './App';
ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import App  from './App';

ReactDOM.render(<App />, document.getElementById('root'));
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-react-buttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-react-layouts/styles/tailwind3.css";

#container {
  margin: 0 auto;
  width: 600px;
}

.e-panel-container .content {
  vertical-align: middle;
  font-weight: 600;
  font-size: 20px;
  text-align: center;
  line-height: 90px;
}

div#properties {
  width: 205px;
  margin-left: 15px;
  padding: 15px;
  position: absolute;
}

.inline {
  display: inline-block;
}

div#control {
  width: 500px;
}

#restore {
  margin-left: 5px;
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion EJ2 React Dashboard Layout Sample</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-react-layouts/styles/tailwind3.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <link rel="stylesheet" href="App.css">
</head>
<body>
    <div id='root'>
        <div id='loader'>Loading....</div>
    </div>  
</body>
</html>

Refer to the React Dashboard Layout feature tour page for feature highlights. Also explore the React Dashboard Layout example to know how to display and manipulate data.